Package: goSTAG
Type: Package
Title: A tool to use GO Subtrees to Tag and Annotate Genes within a set
Version: 1.37.0
Date: 2017-06-02
Author: Brian D. Bennett and Pierre R. Bushel
Maintainer: Brian D. Bennett <brian.bennett@nih.gov>
Description: Gene lists derived from the results of genomic analyses are rich in biological information. For instance, differentially expressed genes (DEGs) from a microarray or RNA-Seq analysis are related functionally in terms of their response to a treatment or condition. Gene lists can vary in size, up to several thousand genes, depending on the robustness of the perturbations or how widely different the conditions are biologically. Having a way to associate biological relatedness between hundreds and thousands of genes systematically is impractical by manually curating the annotation and function of each gene. Over-representation analysis (ORA) of genes was developed to identify biological themes. Given a Gene Ontology (GO) and an annotation of genes that indicate the categories each one fits into, significance of the over-representation of the genes within the ontological categories is determined by a Fisher's exact test or modeling according to a hypergeometric distribution. Comparing a small number of enriched biological categories for a few samples is manageable using Venn diagrams or other means for assessing overlaps. However, with hundreds of enriched categories and many samples, the comparisons are laborious. Furthermore, if there are enriched categories that are shared between samples, trying to represent a common theme across them is highly subjective. goSTAG uses GO subtrees to tag and annotate genes within a set. goSTAG visualizes the similarities between the over-representation of DEGs by clustering the p-values from the enrichment statistical tests and labels clusters with the GO term that has the most paths to the root within the subtree generated from all the GO terms in the cluster.
License: GPL-3
Depends: R (>= 3.4)
Imports: AnnotationDbi, biomaRt, GO.db, graphics, memoise, stats, utils
Suggests: BiocStyle, knitr, rmarkdown, testthat
VignetteBuilder: knitr
LazyData: true
biocViews: GeneExpression, DifferentialExpression, GeneSetEnrichment,
        Clustering, Microarray, mRNAMicroarray, RNASeq, Visualization,
        GO, ImmunoOncology
git_url: https://git.bioconductor.org/packages/goSTAG
git_branch: devel
git_last_commit: 5ee3554
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:58:02 UTC; biocbuild

loadGOTerms = function( species = "human", domain = "BP", min_num_genes = 5, use_archived = TRUE ) {
    ## Make sure a valid domain is specified
    if( ! toupper(domain) %in% c("BP","CC","MF") ) {
        stop( "Invalid domain" )
    }

    ## Load the domains for each GO term from the GO.db package
    domains = Ontology(GOTERM)

    if( use_archived == TRUE ) {
        ## Load the gene annotations from the archived version within the package
        go_genes_all = switch( toupper(species),
            HUMAN = goSTAG::goSTAG_go_genes_human,
            MOUSE = goSTAG::goSTAG_go_genes_mouse,
            RAT = goSTAG::goSTAG_go_genes_rat,
            stop( "Invalid species" )
        )

        ## Filter the GO terms to only include those in the specified domain
        go_genes = go_genes_all[ domains[names(go_genes_all)]==toupper(domain) ]

        ## Add full list of all annotated genes
        go_genes[[ "ALL" ]] = go_genes_all[[ "ALL" ]]
    } else {
        ## Set the correct BioMart dataset and gene symbol attribute for the specified species
        ensembl_dataset = switch( toupper(species),
            HUMAN = "hsapiens_gene_ensembl",
            MOUSE = "mmusculus_gene_ensembl",
            RAT = "rnorvegicus_gene_ensembl",
            stop( "Invalid species" )
        )
        gene_symbol_attribute = switch( toupper(species),
            HUMAN = "hgnc_symbol",
            MOUSE = "mgi_symbol",
            RAT = "rgd_symbol",
            stop( "Invalid species" )
        )

        ## Connect to BioMart using the biomaRt package
        ensembl_mart = useMart( biomart="ENSEMBL_MART_ENSEMBL", host="grch37.ensembl.org", path="/biomart/martservice", dataset=ensembl_dataset )

        ## Get the complete list of GO terms and associated gene symbols from BioMart
        query = getBM( attributes = c(gene_symbol_attribute,"go_id"), mart = ensembl_mart )
        query = query[ query[,1]!="", ]
        query = query[ query[,2]!="", ]

        ## Filter the BioMart query to only include valid GO terms from the specified domain
        go_ids = unique(query[,2])
        go_ids_filtered = go_ids[ domains[go_ids]==toupper(domain) ]
        go_ids_filtered = go_ids_filtered[ ! is.na(go_ids_filtered) ]
        query_filtered = query[ query[,2] %in% go_ids_filtered, ]

        ## Get the list of gene annotations for each GO term
        go_genes = lapply( go_ids_filtered, function(x) unique(query_filtered[query_filtered[,2]==x,1]) )
        names(go_genes) = go_ids_filtered

        ## Add full list of all annotated genes
        go_genes[[ "ALL" ]] = unique(query[,1])
    }

    ## Filter out any GO term with fewer that the specified minimum number of genes
    go_genes[ lapply(go_genes,length) >= min_num_genes ]
}

performGOEnrichment = function( gene_lists, go_terms, filter_method = "pval", significance_threshold = 0.05, p.adjust_method = "BH" ) {
    ## Separate all annotated genes from GO terms
    if( ! is.null( go_terms[["ALL"]] ) ) {
        all_genes = go_terms[["ALL"]]
        go_terms[["ALL"]] = NULL
    } else {
        stop( "All annotated genes entry missing in GO terms list" )
    }

    ## Calculate the gene list sizes and the universe size for the hypergeometric test
    gene_list_sizes = vapply( gene_lists, function(x) {
        length( intersect( toupper(x), toupper(all_genes) ) )
    }, integer(1) )
    universe_size = length( unique(toupper(all_genes)) )

    ## Calculate a p-value for each GO term and gene list using the hypergeometric test
    pvals = matrix( nrow = length(go_terms), ncol = length(gene_lists) )
    for( i in seq_len( length(go_terms) ) ) {
        m = length( intersect( toupper(go_terms[[i]]), toupper(all_genes) ) )
        pvals[i,] = vapply( seq_len( length(gene_lists) ), function(j) {
            x = length( intersect( toupper(go_terms[[i]]), toupper(gene_lists[[j]]) ) )
            k = gene_list_sizes[j]
            N = universe_size
            phyper( x-1, m, N-m, k, lower.tail=FALSE )
        }, numeric(1) )
    }
    rownames(pvals) = names(go_terms)
    colnames(pvals) = names(gene_lists)

    ## Use the p.adjust method to calculate adjusted p-values
    adjusted_pvals = matrix( nrow = length(go_terms), ncol = length(gene_lists) )
    for( i in seq_len( length(gene_lists) ) ) {
        adjusted_pvals[,i] = p.adjust( pvals[,i], method = p.adjust_method )
    }

    ## Filter out GO terms that don't have any significant tests
    if( toupper( filter_method ) == "PVAL" ) {
        final_matrix = pvals[ apply( pvals<significance_threshold, 1, sum ) > 0, ]
        final_matrix[ final_matrix>=significance_threshold ] = 1
    } else if( toupper( filter_method ) == "P.ADJUST" ) {
        final_matrix = pvals
        final_matrix[ adjusted_pvals>=significance_threshold ] = 1
        final_matrix = final_matrix[ apply( adjusted_pvals<significance_threshold, 1, sum ) > 0, ]
    } else {
        stop( "Invalid filter method" )
    }

    ## Tranform the p-values to -log10
    final_matrix = -log10( final_matrix )

    ## Throw an error if there are not two or more significant GO terms
    if( dim(final_matrix)[1] == 0 ) {
        stop( "Zero significant GO terms (try less stringent signficance threshold)" )
    } else if( dim(final_matrix)[1] == 1 ) {
        stop( "Only one significant GO term (try less stringent signficance threshold)" )
    }

    ## Remove infinite values by replacing them with the next highest value
    final_matrix[is.infinite(final_matrix)] = max(final_matrix[!is.infinite(final_matrix)])

    final_matrix
}

plotHeatmap = function( enrichment_matrix, hclust_results, clusters, cluster_labels, sample_hclust_results = NULL, min_num_terms = 10, maximum_heatmap_value = 10, heatmap_colors = "auto", sample_colors = NULL, margin_size = 0.01, dendrogram_width = 0.4, cluster_label_width = 0.5, header_height = 0.3, sample_label_height = 0.6, dendrogram_lwd = 1, header_lwd = 1, cluster_label_cex = 1, sample_label_cex = 1 ) {
    ## Skip the following if externally generated heatmap colors are provided
    if( length( heatmap_colors ) == 1 ) {
        ## Define the number of colors to use and the depth of the grey
        num_colors = 256
        grey_value = 200

        if( toupper(heatmap_colors) == "AUTO" ) {
            ## Define heatmap colors from grey to red
            heatmap_colors = vapply( seq_len( num_colors ), function(i) {
                paste( sep="", "#", format( as.hexmode( as.integer( grey_value + (255-grey_value) * (i-1) / (num_colors-1) ) ), width = 2 ), format( as.hexmode( as.integer( grey_value * (num_colors-i) / (num_colors-1) ) ), width = 2 ), format( as.hexmode( as.integer( grey_value * (num_colors-i) / (num_colors-1) ) ), width = 2 ) )
            }, character(1) )
        } else if( toupper(heatmap_colors) == "EXTRA" ) {
            ## Define heatmap colors from grey to yellow to red
            heatmap_colors1 = vapply( seq_len( num_colors ), function(i) {
                paste( sep="", "#", format( as.hexmode( as.integer( grey_value + (255-grey_value) * (i-1) / (num_colors-1) ) ), width = 2 ), format( as.hexmode( as.integer( grey_value + (255-grey_value) * (i-1) / (num_colors-1) ) ), width = 2 ), format( as.hexmode( as.integer( grey_value * (num_colors-i) / (num_colors-1) ) ), width = 2 ) )
            }, character(1) )
            heatmap_colors2 = vapply( seq_len( num_colors-1 ), function(i) {
                paste( sep="", "#ff", format( as.hexmode( as.integer( 255 * (num_colors-i-1) / (num_colors-1) ) ), width = 2 ), "00" )
            }, character(1) )
            heatmap_colors = c( heatmap_colors1, heatmap_colors2 )
        }
    }

    ## Define a function to get smaller labels
    get_smaller_labels = function( label ) {
        vapply( seq_len( nchar(label)-1 ), function(i) {
            paste( sep="", substr( label, 1, i ), "..." )
        }, character(1) )
    }

    ## Identify the distance cutoff in the dendrogram based on the number of clusters
    if( length(clusters) == length(hclust_results$order) ) {
        distance_cutoff = 0
    } else {
        distance_cutoff = hclust_results$height[ length(hclust_results$order) - length(clusters) ]
    }

    ## Create the properly formatted clusters dendrogram to plot
    label_width = max(hclust_results$height) * cluster_label_width / ( 1 - cluster_label_width )
    hclust_results$height[ hclust_results$height<=distance_cutoff ] = 0
    hclust_results$height = hclust_results$height + label_width
    dendrogram = cut( as.dendrogram( hclust_results ), h = distance_cutoff + label_width )$upper

    ## Create the header dendrogram if required
    if( is.null( sample_hclust_results ) ) {
        label_height = 1
    } else {
        label_height = max(sample_hclust_results$height) * sample_label_height / ( 1 - sample_label_height )
        sample_hclust_results$height = sample_hclust_results$height + label_height
        header_dendrogram = as.dendrogram( sample_hclust_results )
    }

    ## Set up the plot area and the three screens
    par( mar = c(0,0,0,0) )
    aspect_ratio = (par("pin")[1]/diff(par("usr")[1:2])) / (par("pin")[2]/diff(par("usr")[3:4]))
    heatmap_margin_y = margin_size * aspect_ratio
    x1 = margin_size
    x2 = margin_size + dendrogram_width * ( 1 - 3 * margin_size )
    x3 = 2 * margin_size + dendrogram_width * ( 1 - 3 * margin_size )
    x4 = 1 - margin_size
    y1 = heatmap_margin_y
    y2 = heatmap_margin_y + ( 1 - header_height ) * ( 1 - 3 * heatmap_margin_y )
    y3 = 2 * heatmap_margin_y + ( 1 - header_height ) * ( 1 - 3 * heatmap_margin_y )
    y4 = 1 - heatmap_margin_y
    screens = split.screen( rbind( c(x3,x4,y1,y2), c(0,x3,0,y3), c(x2,1,y2,1) ) )

    ## Plot screen one, the heatmap
    screen(screens[1])

    ## Floor any values in the matrix that are greater than the maximum
    enrichment_matrix[ enrichment_matrix > maximum_heatmap_value ] = maximum_heatmap_value

    ## Plot the heatmap
    if( is.null( sample_hclust_results ) ) {
        image( t( enrichment_matrix[ hclust_results$order, ] ), axes = FALSE, col = heatmap_colors )
    } else {
        image( t( enrichment_matrix[ hclust_results$order, sample_hclust_results$order ] ), axes = FALSE, col = heatmap_colors )
    }

    ## Plot screen two, the clusters dendrogram
    screen(screens[2])
    par( lwd = dendrogram_lwd )
    x_size = max(hclust_results$height)
    x_margin = x_size * ( margin_size / ( dendrogram_width * ( 1 - 3 * margin_size ) ) )
    y_size = length(hclust_results$order)
    y_margin = y_size * ( heatmap_margin_y / ( ( 1 - header_height ) * ( 1 - 3 * heatmap_margin_y ) ) )

    ## Plot the dendrogram
    plot( dendrogram, center = TRUE, horiz = TRUE, leaflab = "none", axes = FALSE, xaxs="i", yaxs="i", xlim = c(x_size+x_margin,-x_margin), ylim = c(-y_margin+0.5,y_size+y_margin+0.5) )

    ## Plot a white box to hide dendrogram lines past the label
    rect( -x_margin, -y_margin, label_width, y_size+y_margin, col = "white", border = "NA" )

    ## Cycle through all clusters
    cluster_num_members = vapply( clusters, length, integer(1) )
    for( i in seq_len( length(clusters) ) ) {
        ## Only plot the label if it has more than the required number of terms
        if( cluster_num_members[i] >= min_num_terms ) {
            ## Plot the label box
            rect( 0, sum(cluster_num_members[seq_len(i-1)])+0.5, label_width, sum(cluster_num_members[seq_len(i)])+0.5 )

            ## Get the label and make it smaller if it is bigger than the box
            label = cluster_labels[i]
            if( - strwidth( label, cex = cluster_label_cex ) > label_width ) {
                smaller_labels = get_smaller_labels( label )
                label = smaller_labels[ max( which( - strwidth( smaller_labels, cex = cluster_label_cex ) <= label_width ) ) ]
            }

            ## Plot the label text
            text( label_width/2, sum(cluster_num_members[seq_len(i-1)])+0.5+cluster_num_members[i]/2, label, cex = cluster_label_cex )
        }
    }

    ## Plot screen three, the header
    screen(screens[3])
    par( lwd = header_lwd )
    x_size = dim(enrichment_matrix)[2]
    x_margin = x_size * ( margin_size / ( ( 1 - dendrogram_width ) * ( 1 - 3 * margin_size ) ) )
    if( is.null( sample_hclust_results ) ) {
        y_size = label_height
    } else {
        y_size = max(sample_hclust_results$height)
    }
    y_margin = y_size * ( heatmap_margin_y / ( header_height * ( 1 - 3 * heatmap_margin_y ) ) )

    ## The header is different based on whether there is a dendrogram or not
    if( is.null( sample_hclust_results ) ) {
        ## Set up the plot area with no dendrogram
        plot( NULL, axes = FALSE, xaxs="i", yaxs="i",  xlim = c(-x_margin+0.5,x_size+x_margin+0.5), ylim = c(-y_margin,y_size+y_margin) )
    } else {
        ## Plot the dendrogam
        plot( header_dendrogram, leaflab = "none", axes = FALSE, xaxs="i", yaxs="i", xlim = c(-x_margin+0.5,x_size+x_margin+0.5), ylim = c(-y_margin,y_size+y_margin) )

        ## Plot a white box to hide dendrogram lines past the label
        rect( -x_margin, -y_margin, x_size+x_margin, label_height, col = "white", border = "NA" )
    }

    ## Cycle through all samples
    for( i in seq_len( dim(enrichment_matrix)[2] ) ) {
        ## Plot the label box
        if( is.null( sample_colors ) ) {
            if( ! is.null( sample_hclust_results ) ) {
                rect( i-1+0.5, 0, i+0.5, label_height )
            }
        } else {
            if( is.null( sample_hclust_results ) ) {
                rect( i-1+0.5, 0, i+0.5, label_height, col = sample_colors[i] )
            } else {
                rect( i-1+0.5, 0, i+0.5, label_height, col = sample_colors[sample_hclust_results$order][i] )
            }
        }

        ## Get the label and make it smaller if it is bigger than the box
        if( is.null( sample_hclust_results ) ) {
            label = colnames(enrichment_matrix)[i]
        } else {
            label = colnames(enrichment_matrix)[sample_hclust_results$order][i]
        }
        if( strwidth( label, cex = sample_label_cex ) * ((y_size+2*y_margin)/(x_size+2*x_margin)) * (par("pin")[1]/par("pin")[2]) > label_height ) {
            smaller_labels = get_smaller_labels( label )
            label = smaller_labels[ max( which( strwidth( smaller_labels, cex = sample_label_cex ) * ((y_size+2*y_margin)/(x_size+2*x_margin)) * (par("pin")[1]/par("pin")[2]) <= label_height ) ) ]
        }

        ## Plot the label text
        if( is.null( sample_colors ) && is.null( sample_hclust_results ) ) {
            text( i, 0, label, cex = sample_label_cex, srt = 90, pos = 4 )
        } else {
            text( i, label_height/2, label, cex = sample_label_cex, srt = 90 )
        }
    }

    ## Close the screens
    close.screen( all.screens = TRUE )
}

loadGeneLists = function( location, type = "GMT", sep = "\t", header = FALSE, col = 1 ) {
    if( toupper(type) == "GMT" ) {
        ## Load in the gene lists from the GMT file
        raw_data = strsplit( scan( location, what = "character", sep = "\n", quiet = TRUE ), sep )
        gene_lists = lapply( raw_data, function(x) { keep = x!=""; keep[1:2] = FALSE; unique(x[keep]) } )
        names( gene_lists ) = vapply( raw_data, function(x) x[1], character(1) )
        gene_lists
    } else if( toupper(type) == "DIR" ) {
        ## Identify the gene list files within the directory
        gene_list_files = list.files( location )
        gene_list_files_full = paste( sep="", location, "/", gene_list_files )

        ## Load in the gene lists from the files in the directory
        gene_lists = lapply( seq_len( length(gene_list_files) ), function(i) {
            raw_data = read.table( gene_list_files_full[i], header = FALSE, sep = sep )
            if( header == TRUE ) {
                as.character( raw_data[-1,col] )
            } else {
                as.character( raw_data[,col] )
            }
        } )
        names( gene_lists ) = vapply( gene_list_files, function(x) if( substr(x,nchar(x)-3,nchar(x)) == ".txt" ) { substr(x,1,nchar(x)-4) } else { x }, character(1) )
        gene_lists
    } else {
        stop( "Invalid type" )
    }
}

annotateClusters = function( clusters ) {
    ## Load the GO parents from the GO.db package
    parents = switch( Ontology( GOTERM[ clusters[[1]][1] ] ),
        BP = as.list(GOBPPARENTS),
        CC = as.list(GOCCPARENTS),
        MF = as.list(GOMFPARENTS),
        stop( "Invalid domain" )
    )

    ## Define the recursive function to get the number of paths to the root
    get_num_paths = memoise( function( go_id ) {
        this_parents = parents[[go_id]]
        this_parents = this_parents[ names(this_parents) == "isa" ]
        if( this_parents[1] == "all" ) {
            1L
        } else {
            sum( vapply( this_parents, get_num_paths, integer(1) ) )
        }
    } )

    ## Cycle through all the clusters
    idx = vapply( clusters, function(cluster) {
        ## Get the number of paths to the root for each GO term in the cluster
        num_paths = vapply( cluster, get_num_paths, integer(1) )

        ## Select the GO term with the largest number of paths to the root
        cluster[ which.max(num_paths) ]
    }, character(1) )

    Term( GOTERM[ idx ] )
}

performHierarchicalClustering = function( enrichment_matrix, feature = "row", distance_method = "correlation", clustering_method = "average" ) {
    ## To cluster the columns, transpose the enrichment matrix
    final_matrix = switch( toupper( feature ),
        ROW = enrichment_matrix,
        COL = t(enrichment_matrix),
        stop( "Invalid feature" )
    )

    if( toupper( distance_method ) == "CORRELATION" ) {
        ## Cluster using the hclust function with a distance based on the correlation
        hclust( as.dist( 1-abs(cor(t(final_matrix))) ), method = clustering_method )
    } else {
        ## Cluster using the hclust function with a distance based on the dist function
        hclust( dist( final_matrix, method = distance_method ), method = clustering_method )
    }
}

groupClusters = function( hclust_results, distance_threshold = 0.2 ) {
    ## Define the recursive function to get the root leaf for a given step of the merging
    get_root = function( hclust_results, step ) {
        if( hclust_results$merge[ step, 1 ] < 0 ) {
            hclust_results$merge[ step, 1 ]
        } else {
            get_root( hclust_results, hclust_results$merge[ step, 1 ] )
        }
    }

    ## Initialize each leaf to their own cluster
    hclust_clusters = seq_len( length(hclust_results$order) )

    ## Make sure there are at least two leaves tha are closer than the threshold 
    if( sum(hclust_results$height<=distance_threshold) >= 1 ) {

        ## Cycle through all leaves whose distance is less than the threshold
        for( i in seq_len( sum(hclust_results$height<=distance_threshold) ) ) {

            ## Assign the leaf to a cluster based on who it is merged with
            if( hclust_results$merge[i,1] < 0 && hclust_results$merge[i,2] < 0 ) {
                hclust_clusters[ -hclust_results$merge[i,1] ] = hclust_clusters[ -hclust_results$merge[i,2] ]
            } else if( hclust_results$merge[i,1] < 0 && hclust_results$merge[i,2] > 0 ) {
                hclust_clusters[ -hclust_results$merge[i,1] ] = hclust_clusters[ -get_root( hclust_results, hclust_results$merge[i,2] ) ]
            } else if( hclust_results$merge[i,1] > 0 && hclust_results$merge[i,2] > 0 ) {
                hclust_clusters[ hclust_clusters == hclust_clusters[ -get_root( hclust_results, hclust_results$merge[i,1] ) ] ] = hclust_clusters[ -get_root( hclust_results, hclust_results$merge[i,2] ) ]
            }
        }
    }

    ## Give each leaf a cluster number
    hclust_final_clusters = rep( 1, length(hclust_results$order) )
    for( i in seq( 2, length(hclust_results$order) ) ) {
        if( hclust_clusters[ hclust_results$order[i] ] == hclust_clusters[ hclust_results$order[i-1] ] ) {
            hclust_final_clusters[i] = hclust_final_clusters[i-1]
        } else {
            hclust_final_clusters[i] = hclust_final_clusters[i-1] + 1
        }
    }

    ## Make the list of clusters containing the leaves within each cluster
    clusters = lapply( seq_len( max(hclust_final_clusters) ), function(i) {
        hclust_results$labels[ hclust_results$order[ hclust_final_clusters==i ] ]
    } )
    names(clusters) = paste( sep="", "Cluster", seq_len( max(hclust_final_clusters) ) )

    clusters
}

---
title: "The goSTAG User's Guide"
author: "Brian D. Bennett and Pierre R. Bushel"
date: "June 2, 2017"
output: 
    BiocStyle::html_document:
        toc_float: true
vignette: >
    %\VignetteIndexEntry{The goSTAG User's Guide}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

# Introduction

Gene lists derived from the results of genomic analyses are rich in biological information. For instance, differentially expressed genes (DEGs) from a microarray or RNA-Seq analysis are related functionally in terms of their response to a treatment or condition. Gene lists can vary in size, up to several thousand genes, depending on the robustness of the perturbations or how widely different the conditions are biologically. Having a way to associate biological relatedness between hundreds and thousands of genes systematically is impractical by manually curating the annotation and function of each gene. Over-representation analysis (ORA) of genes was developed to identify biological themes. Given a Gene Ontology (GO) and an annotation of genes that indicate the categories each one fits into, significance of the over-representation of the genes within the ontological categories is determined by a Fisher's exact test or modeling according to a hypergeometric distribution. Comparing a small number of enriched biological categories for a few samples is manageable using Venn diagrams or other means for assessing overlaps. However, with hundreds of enriched categories and many samples, the comparisons are laborious. Furthermore, if there are enriched categories that are shared between samples, trying to represent a common theme across them is highly subjective. goSTAG uses GO subtrees to tag and annotate genes within a set. goSTAG visualizes the similarities between the over-representation of DEGs by clustering the p-values from the enrichment statistical tests and labels clusters with the GO term that has the most paths to the root within the subtree generated from all the GO terms in the cluster.

# Installation

The goSTAG package is available through Bioconductor and you can install it by running:

```{r, eval = FALSE}
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("goSTAG")
```

Once the library is installed, you can load it by running:

```{r, warning = FALSE, message = FALSE}
library("goSTAG")
```

# Preparing Data for Analysis

This section describes how to prepare your data to perform a goSTAG analysis.

## Gene Lists

The key input data that goSTAG requires is a set of gene lists. These gene lists can be derived from any type of gene-based analysis, such as differential expression analysis or ChIP-seq peak targets. They can be generated within R using another package, or using an external tool and then loaded into R.

Once you have generated your gene lists and loaded them into R, you must convert them into the format that goSTAG requires, which is a list of vectors. Each element of the list corresponds to a gene list, and the vectors contain the genes in the gene list.

We provide an example set of gene lists in the goSTAG package.

```{r}
data( goSTAG_example_gene_lists )
head( lapply( goSTAG_example_gene_lists, head ) )
```

For convienience, we have provided a function for loading external gene lists.

The first option is to put your gene lists into a single GMT file. This GMT file is a tab-delimited file containing one gene list per line. The first entry in the line is the name of the gene list, the second entry in the line is a description of the gene list (which goSTAG ignores), and the rest of the entries are the genes. For more information on the GMT format, see [here](http://software.broadinstitute.org/cancer/software/gsea/wiki/index.php/Data_formats#GMT:_Gene_Matrix_Transposed_file_format_.28.2A.gmt.29).

Once you have created your GMT file, you can load it using the `loadGeneLists` function.

```{r, eval = FALSE}
gene_lists <- loadGeneLists( "gene_lists.gmt" )
```

The second option is to have your gene lists in separate tab-delimited text files within a directory.

You can load the gene lists within this directory using the `loadGeneLists` function with the `type` argument set to `"DIR"`.

```{r, eval = FALSE}
gene_lists <- loadGeneLists( "/gene/lists/directory", type = "DIR" )
```

By default, the `loadGeneLists` function expects the files in this directory to have no header and to have the genes in the first column. You can modify this behavior using the `header` argument and the `col` argument.

In this example, the files contain a header that needs to be ignored, and the genes are in the 7th column.

```{r, eval = FALSE}
gene_lists <- loadGeneLists( "/gene/lists/directory", type = "DIR", header = TRUE, col = 7 )
```

## GO Terms

The second input data required by goSTAG is a set of GO terms and the genes associated with those GO terms. The GO terms should all belong to the same GO domain (either biological process, cellular component, or molecular function). The expected format is a list of vectors, where each list corresponds to a GO term, and the vectors contain the genes associated with the GO terms. The names of the lists should be the GO IDs of the GO terms. The list must also have an additional element named "ALL", which is a vector that contains all annotated genes.

The goSTAG package provides the `loadGOTerms` function for loading the GO terms and gene associations from BioMart using the `biomaRt` package.

```{r, warning = FALSE, message = FALSE}
go_terms <- loadGOTerms()
head( lapply( go_terms, head ) )
head( go_terms[["ALL"]] )
```

Since loading the GO terms from BioMart can take several minutes, the default behavior of the `loadGOTerms` function is to use a previously generated version that has been archived in the goSTAG package, which is much faster.

You can load the most recent version of the GO terms and gene associations directly from BioMart by setting the `use_archived` argument to `FALSE`.

```{r, eval = FALSE}
go_terms <- loadGOTerms( use_archived = FALSE )
```

By default, the `loadGOTerms` function will associate genes based on the annotation for human. It will also load GO terms for the biological process domain and remove any GO terms that has fewer than 5 genes associated with it. To modify this behavior, use the `species`, `domain`, and `min_num_genes` arguments. Currently, the supported options for the `species` argument are "human", "mouse", or "rat".  Acceptable options for the `domain` argument are "BP" (biological process), "CC" (cellular component), or "MF" (molecular function).

This example will load GO terms for mouse, using the molecular function domain, and remove any GO terms with fewer than 10 genes.

```{r}
go_terms_mouse <- loadGOTerms( species = "mouse", domain = "MF", min_num_genes = 10 )
```

# Running goSTAG

Once your gene lists and GO terms are loaded, you are ready to perform a goSTAG analysis. This section will detail the four steps in the goSTAG analysis.

## Generating the Enrichment Matrix

The first step is to create a matrix of GO enrichment scores. The goSTAG package calculates an enrichment score for each gene list and GO term using the hypergeometric test. It will remove any GO term that has no samples with significant enrichment. The enrichment score is calculated as the -log10 p-value of the hypergeometric test. For tests without significant enrichment, the enrichment score is set to 0.

To generate an enrichment matrix from your gene lists and GO terms, use the `performGOEnrichment` function.

```{r}
enrichment_matrix <- performGOEnrichment( goSTAG_example_gene_lists, go_terms )
head(enrichment_matrix)
```

This function produces a matrix of enrichment scores, where columns are gene lists and rows are GO terms.

By default, this function will remove any GO term where none of the samples have a p-value of less than 0.05. You can specify whether to use a nominal p-value or an adjusted p-value using the `filter_method` argument, and you can change the significance threshold using the `significance_threshold` argument. This function uses the `p.adjust` method to adjust the p-value, and you can specify the method used to adjust the p-values with the `p.adjust_method` argument. See the `method` argument for the `p.adjust` function for available options.

This example generates the enrichment matrix and uses a Benjamini-Hochberg FDR of 0.3 to filter the GO terms.

```{r, eval = FALSE}
enrichment_matrix_FDR <- performGOEnrichment( goSTAG_example_gene_lists, go_terms, filter_method = "p.adjust", significance_threshold = 0.3, p.adjust_method = "BH" )
```

## Hierarchical Clustering

After generating the enrichment matrix, the next step is to cluster the GO terms. Before clustering the GO terms into groups, you must first perform hierarchical clustering.

You can perform the hierarchical clustering using the `performHierarchicalClustering` function.

```{r}
hclust_results <- performHierarchicalClustering( enrichment_matrix )
hclust_results
```

This function uses the `hclust` function and returns an object of class `hclust` containing the hierarchical clustering tree.

By default, this function uses one minus the absolute value of the correlation to measure distance. You can change this behavior using the `distance_method` argument. Specifying anything other than `correlation` will cause this function to use the `dist` function to measure distance. The method specified in the `distance_method` argument is the method that the `dist` function will use. See the `method` argument for the `dist` function for available options.

This function uses the `hclust` function to perform the hierarchical clustering, with a default agglomeration method of `average`. You can change this by specifying the `clustering_method` argument.

This example performs hierarchical clustering on the GO terms using Euclidean distance and complete agglomeration.

```{r}
hclust_results_euclidean <- performHierarchicalClustering( enrichment_matrix, distance_method = "euclidean", clustering_method = "complete" )
```

You can also perform hierarchical clustering on the samples by setting the `feature` argument to `col`.

```{r}
sample_hclust_results <- performHierarchicalClustering( enrichment_matrix, feature = "col" )
```

## Grouping the Clusters

After the hierarchical clustering is complete, you can group the GO terms into clusters using the `groupClusters` function.

```{r}
clusters <- groupClusters( hclust_results_euclidean )
lapply( head( clusters ), head )
```

This function produces a list of vectors, where each list corresponds to a cluster, and the vectors are the GO terms in the clusters.

By default, this function will group GO terms whose distance to each other is less than 0.2. This threshold can be adjusted by changing the `distance_threshold` argument. A larger distance threshold will produce fewer clusters with more GO terms, whereas a smaller one will produce more clusters with fewer GO terms.

The default distance threshold of 0.2 produces a moderate number of clusters.

```{r}
length( clusters )
```

Increasing the distance threshold to 0.5 produces fewer clusters, but with more GO terms on average.

```{r}
clusters_larger_threshold <- groupClusters( hclust_results_euclidean, distance_threshold = 0.5 )
length( clusters_larger_threshold )
```

Whereas decreasing the distance threshold to 0.05 produces more clusters, but with fewer GO terms on average.

```{r}
clusters_smaller_threshold <- groupClusters( hclust_results_euclidean, distance_threshold = 0.05 )
length( clusters_smaller_threshold )
```

## Annotating the Clusters

The final step is to annotate each of the clusters using the GO term within each cluster's subtree that has the most paths back to the root.

You can annotate the clusters using this method with the `annotateClusters` function.

```{r}
cluster_labels <- annotateClusters( clusters )
head( cluster_labels )
```

This returns a vector containing the descriptions of the GO terms tagged to each cluster.

# Plotting a Heatmap

After performing a goSTAG analysis, you can plot a heatmap of the results using the `plotHeatmap` function.

```{r}
plotHeatmap( enrichment_matrix, hclust_results_euclidean, clusters, cluster_labels )
```

You can add the hierarchical clustering of the samples to the plot using the `sample_hclust_results` argument.

```{r}
plotHeatmap( enrichment_matrix, hclust_results_euclidean, clusters, cluster_labels, sample_hclust_results = sample_hclust_results )
```

By default, this function will only label clusters with 10 or more GO terms. You can change this by modifying the `min_num_terms` argument.

This example has the minimum number of GO terms decreased to 5, which increases the number of clusters that are labeled.

```{r}
plotHeatmap( enrichment_matrix, hclust_results_euclidean, clusters, cluster_labels, min_num_terms = 5 )
```

There are many additional graphical arguments that adjust the color, contrast, shape, and size of the heatmap, including `maximum_heatmap_value`, `heatmap_colors`, `sample_colors`, `margin_size`, `dendrogram_width`, `cluster_label_width`, `header_height`, `sample_label_height`, `dendrogram_lwd`, `header_lwd`, `cluster_label_cex`, `sample_label_cex`. For more information about these parameters, see the `plotHeatmap` documentation.

The produce a better quality heatmap image, we recommend creating a high resolution image. When using a higher resolution, we also recommend increasing the line thickness using the `dendrogram_lwd` and `header_lwd` arguments, and the text size using the `cluster_label_cex` and `sample_label_cex` arguments.

Here is example that creates a higher reolution and better quality image.

```{r, eval = FALSE}
png( "heatmap.png", width = 1600, height = 1200 )
plotHeatmap( enrichment_matrix, hclust_results_euclidean, clusters, cluster_labels, dendrogram_lwd = 2, header_lwd = 2, cluster_label_cex = 2, sample_label_cex = 2 )
dev.off()
```

# Citing goSTAG

```{r}
citation("goSTAG")
```

You can contact the authors through email.

Brian D. Bennett: <brian.bennett@nih.gov>

Pierre R. Bushel: <bushel@niehs.nih.gov>

# Session Info

```{r}
sessionInfo()
```

\name{groupClusters}
\alias{groupClusters}
\title{Group Clusters}
\description{
Groups similar leaves of a hierarchical cluster analysis into clusters.
}
\usage{
groupClusters(hclust_results, distance_threshold = 0.2)
}
\arguments{
    \item{hclust_results}{
    An object of class "hclust" containing a tree produced by hierarchical clustering.
    }
    \item{distance_threshold}{
    The distance threshold at which to group leaves into clusters. Leaves whose distance is less than or equal to this threshold will be grouped together. A larger distance threshold will produce fewer clusters with more members, whereas a smaller one will produce more clusters with fewer members.
    }
}
\value{
A list of vectors. Each element of the list corresponds to a cluster, and each vector contains the GO terms in the cluster.
}
\references{
Bennett BD and Bushel PR. goSTAG: Gene Ontology Subtrees to Tag and Annotate Genes within a set. Source Code Biol Med. 2017 Apr 13.
}
\author{
Brian D. Bennett\cr
Pierre R. Bushel
}
\examples{
data( goSTAG_example_gene_lists )
go_terms <- loadGOTerms()
enrichment_matrix <- performGOEnrichment( goSTAG_example_gene_lists, go_terms )
hclust_results <- performHierarchicalClustering( enrichment_matrix )

clusters <- groupClusters( hclust_results )
lapply( head( clusters ), head )
}

\name{goSTAG_go_genes_rat}
\alias{goSTAG_go_genes_rat}
\docType{data}
\title{goSTAG GO Genes (Rat)}
\description{
A list of GO terms and the rat genes associated with them.
}
\usage{data(goSTAG_go_genes_rat)}
\details{
This data is meant for internal goSTAG use.
}
\value{
A list of vectors. Each element of the list corresponds to a GO term, and each vector contains the genes associated with the GO term. The list also has an additional element named "ALL", which is a vector that contains all annotated genes.
}
\references{
Bennett BD and Bushel PR. goSTAG: Gene Ontology Subtrees to Tag and Annotate Genes within a set. Source Code Biol Med. 2017 Apr 13.
}
\author{
Brian D. Bennett\cr
Pierre R. Bushel
}
\examples{
data( goSTAG_go_genes_rat )
lapply( head( goSTAG_go_genes_rat ), head )
}
\keyword{datasets}

\name{goSTAG_example_gene_lists}
\alias{goSTAG_example_gene_lists}
\docType{data}
\title{goSTAG Example Gene Lists}
\description{
An example set of gene lists.
}
\usage{data(goSTAG_example_gene_lists)}
\value{
A list of vectors. Each element of the list corresponds to a gene list, and each vector contains the genes in the gene list.
}
\references{
Bennett BD and Bushel PR. goSTAG: Gene Ontology Subtrees to Tag and Annotate Genes within a set. Source Code Biol Med. 2017 Apr 13.
}
\author{
Brian D. Bennett\cr
Pierre R. Bushel
}
\examples{
data( goSTAG_example_gene_lists )
lapply( head( goSTAG_example_gene_lists ), head )
}
\keyword{datasets}

\name{performGOEnrichment}
\alias{performGOEnrichment}
\title{Perform GO Enrichment}
\description{
Performs a GO enrichment analysis on a set of gene lists and GO terms. Will filter out GO terms having no significant enrichment in any of the gene lists.
}
\usage{
performGOEnrichment(gene_lists, go_terms, filter_method = "pval", significance_threshold = 0.05, p.adjust_method = "BH")
}
\arguments{
    \item{gene_lists}{
    A list of vectors. Each element of the list corresponds to a gene list, and each vector contains the genes in the gene list.
    }
    \item{go_terms}{
    A list of vectors. Each element of the list corresponds to a GO term, and each vector contains the genes associated with the GO term. The list must also have an additional element named "ALL", which is a vector that contains all annotated genes.
    }
    \item{filter_method}{
    A value indicating whether to filter out GO terms based on a nominal p-value or an adjusted p-value. Acceptable options are "pval" (nominal p-value) or "p.adjust" (adjusted p-value).
    }
    \item{significance_threshold}{
    The significance threshold at which to filter out GO terms. GO terms with a nominal or adjusted p-value (indicated by "filter_method") of greater than or equal to this threshold in all gene lists will be filtered out.
    }
    \item{p.adjust_method}{
    The correction method used to adjust the p-values. Available options are those of the "method" argument for the "p.adjust" function, which are currently "holm", "hochberg", "hommel", "bonferroni", "BH", "BY", "fdr", or "none". Only applicable when filter_method = "p.adjust".
    }
}
\value{
A matrix of enrichment scores. Rows correspond to GO terms and columns correspond to gene lists.
}
\references{
Bennett BD and Bushel PR. goSTAG: Gene Ontology Subtrees to Tag and Annotate Genes within a set. Source Code Biol Med. 2017 Apr 13.
}
\author{
Brian D. Bennett\cr
Pierre R. Bushel
}
\examples{
data( goSTAG_example_gene_lists )
go_terms <- loadGOTerms()

enrichment_matrix <- performGOEnrichment( goSTAG_example_gene_lists, go_terms )
head( enrichment_matrix )
}

\name{annotateClusters}
\alias{annotateClusters}
\title{Annotate Clusters}
\description{
Annotates each cluster of GO terms with the term containing the most paths to the root.
}
\usage{
annotateClusters(clusters)
}
\arguments{
    \item{clusters}{
    A list of vectors. Each element of the list corresponds to a cluster, and each vector contains the GO terms in the cluster.
    }
}
\details{
All of the GO terms within all of the clusters must belong to the same GO domain (either BP, CC, or MF).
}
\value{
A vector of cluster labels.
}
\references{
Bennett BD and Bushel PR. goSTAG: Gene Ontology Subtrees to Tag and Annotate Genes within a set. Source Code Biol Med. 2017 Apr 13.
}
\author{
Brian D. Bennett\cr
Pierre R. Bushel
}
\examples{
data( goSTAG_example_gene_lists )
go_terms <- loadGOTerms()
enrichment_matrix <- performGOEnrichment( goSTAG_example_gene_lists, go_terms )
hclust_results <- performHierarchicalClustering( enrichment_matrix )
clusters <- groupClusters( hclust_results )

cluster_labels <- annotateClusters( clusters )
head( cluster_labels )
}

\name{plotHeatmap}
\alias{plotHeatmap}
\title{Plot Heatmap}
\description{
Plots a heatmap of goSTAG analysis results.
}
\usage{
plotHeatmap(enrichment_matrix, hclust_results, clusters, cluster_labels, sample_hclust_results = NULL, min_num_terms = 10, maximum_heatmap_value = 10, heatmap_colors = "auto", sample_colors = NULL, margin_size = 0.01, dendrogram_width = 0.4, cluster_label_width = 0.5, header_height = 0.3, sample_label_height = 0.6, dendrogram_lwd = 1, header_lwd = 1, cluster_label_cex = 1, sample_label_cex = 1)
}
\arguments{
    \item{enrichment_matrix}{
    A matrix of enrichment scores. Rows correspond to GO terms and columns correspond to gene lists.
    }
    \item{hclust_results}{
    An object of class "hclust" containing a tree produced by hierarchical clustering. This tree is for the GO terms (rows) in the enrichment matrix.
    }
    \item{clusters}{
    A list of vectors. Each element of the list corresponds to a cluster, and each vector contains the GO terms in the cluster.
    }
    \item{cluster_labels}{
    A vector of cluster labels.
    }
    \item{sample_hclust_results}{
    An object of class "hclust" containing a tree produced by hierarchical clustering. This tree is for the samples (columns) in the enrichment matrix. If NULL (default), the samples will appear in their original order with no dendrogram.
    }
    \item{min_num_terms}{
    The minimum number of GO terms required to plot a cluster label. Any cluster with fewer GO terms will not be labeled.
    }
    \item{maximum_heatmap_value}{
    The maximum value in the heatmap. Any values in the enrichment matrix greater than this value will be made equal to this value. This is to increase contrast in the heatmap by controlling outliers.
    }
    \item{heatmap_colors}{
    The color range for the heatmap. Available options are "auto", "extra", or a vector containing the color range. If "auto" (default), this function will use a color range from grey to red. If "extra", this function will use a color range from grey to yellow to red.
    }
    \item{sample_colors}{
    A vector of colors for the sample labels. If NULL (default), the sample labels will not have any color.
    }
    \item{margin_size}{
    The size of the margin between the elements of the plot, as a percentage of the entire width of the plot.
    }
    \item{dendrogram_width}{
    The size of the GO term dendrogram (including the cluster labels), as a percentage of the entire width of the plot (excluding the margins).
    }
    \item{cluster_label_width}{
    The size of the cluster labels, as a percentage of the GO term dendrogram.
    }
    \item{header_height}{
    The size of the header (including the sample labels), as a percentage of the entire height of the plot (excluding the margins).
    }
    \item{sample_label_height}{
    The size of the sample labels, as a percentage of the header.
    }
    \item{dendrogram_lwd}{
    The width of the GO term dendrogram lines.
    }
    \item{header_lwd}{
    The width of the sample dendrogram lines.
    }
    \item{cluster_label_cex}{
    A value that scales the cluster label text size.
    }
    \item{sample_label_cex}{
    A value that scales the sample label text size.
    }
}
\value{
None, the function is invoked for its side effect.
}
\references{
Bennett BD and Bushel PR. goSTAG: Gene Ontology Subtrees to Tag and Annotate Genes within a set. Source Code Biol Med. 2017 Apr 13.
}
\author{
Brian D. Bennett\cr
Pierre R. Bushel
}
\examples{
data( goSTAG_example_gene_lists )
go_terms <- loadGOTerms()
enrichment_matrix <- performGOEnrichment( goSTAG_example_gene_lists, go_terms )
hclust_results <- performHierarchicalClustering( enrichment_matrix )
clusters <- groupClusters( hclust_results )
cluster_labels <- annotateClusters( clusters )

plotHeatmap( enrichment_matrix, hclust_results, clusters, cluster_labels )
}

\name{performHierarchicalClustering}
\alias{performHierarchicalClustering}
\title{Perform Hierarchical Clustering}
\description{
Performs a hierarchical clustering analysis on a GO enrichment matrix.
}
\usage{
performHierarchicalClustering(enrichment_matrix, feature = "row", distance_method = "correlation", clustering_method = "average")
}
\arguments{
    \item{enrichment_matrix}{
    A matrix of enrichment scores. Rows correspond to GO terms and columns correspond to gene lists.
    }
    \item{feature}{
    A value indicating whether to cluster the rows or the columns. Acceptable options are "row" or "col".
    }
    \item{distance_method}{
    The distance measure to use when generating the distance matrix. If "correlation" (default), this function will use one minus the absolute value of the correlation to measure distance. Otherwise, this function will use the "dist" function to measure distance. Available options are those of the "method" argument for the "dist" function, which are currently "euclidean", "maximum", "manhattan", "canberra", "binary", or "minkowski".
    }
    \item{clustering_method}{
    The agglomeration method to use when performing the hierarchical clustering. Available options are those of the "method" argument for the "hclust" function, which are currently "ward.D", "ward.D2", "single", "complete", "average", "mcquitty", "median", or "centroid".
    }
}
\value{
An object of class "hclust" containing a tree produced by hierarchical clustering.
}
\references{
Bennett BD and Bushel PR. goSTAG: Gene Ontology Subtrees to Tag and Annotate Genes within a set. Source Code Biol Med. 2017 Apr 13.
}
\author{
Brian D. Bennett\cr
Pierre R. Bushel
}
\examples{
data( goSTAG_example_gene_lists )
go_terms <- loadGOTerms()
enrichment_matrix <- performGOEnrichment( goSTAG_example_gene_lists, go_terms )

hclust_results <- performHierarchicalClustering( enrichment_matrix )
sample_hclust_results <- performHierarchicalClustering( enrichment_matrix, feature = "col" )
}

\name{goSTAG-package}
\alias{goSTAG-package}
\alias{goSTAG}
\docType{package}
\title{goSTAG Package}
\description{
A tool to use GO Subtrees to Tag and Annotate Genes within a set.
}
\details{
    \tabular{ll}{
    Package: \tab goSTAG\cr
    Type: \tab Package\cr
    }
}
\author{
Brian D. Bennett\cr
Pierre R. Bushel
}
\references{
Bennett BD and Bushel PR. goSTAG: Gene Ontology Subtrees to Tag and Annotate Genes within a set. Source Code Biol Med. 2017 Apr 13.
}
\keyword{ package }
\examples{
data( goSTAG_example_gene_lists )
go_terms <- loadGOTerms()
enrichment_matrix <- performGOEnrichment( goSTAG_example_gene_lists, go_terms )
hclust_results <- performHierarchicalClustering( enrichment_matrix )
clusters <- groupClusters( hclust_results )
cluster_labels <- annotateClusters( clusters )
plotHeatmap( enrichment_matrix, hclust_results, clusters, cluster_labels )
}

\name{loadGOTerms}
\alias{loadGOTerms}
\title{Load GO Terms}
\description{
Loads a list of GO terms and the genes associated with them.
}
\usage{
loadGOTerms(species = "human", domain = "BP", min_num_genes = 5, use_archived = TRUE)
}
\arguments{
    \item{species}{
    The species to use for associating genes with GO terms. Available options are "human", "mouse", or "rat".
    }
    \item{domain}{
    The GO domain to use. Acceptable options are "BP" (biological process), "CC" (cellular component), or "MF" (molecular function).
    }
    \item{min_num_genes}{
    The minimum number of genes required to be associated with each GO term. Any GO terms with fewer genes will be excluded.
    }
    \item{use_archived}{
    A logical value indicating whether to use an archived version of the gene associations. If FALSE, this function will use BioMart to generate the latest version of the gene associations, but may take several minutes. If TRUE (default), this function will use a previously generated version of the gene associations, which takes very little time.
    }
}
\value{
A list of vectors. Each element of the list corresponds to a GO term, and each vector contains the genes associated with the GO term. The list also has an additional element named "ALL", which is a vector that contains all annotated genes.
}
\references{
Bennett BD and Bushel PR. goSTAG: Gene Ontology Subtrees to Tag and Annotate Genes within a set. Source Code Biol Med. 2017 Apr 13.
}
\author{
Brian D. Bennett\cr
Pierre R. Bushel
}
\examples{
go_terms <- loadGOTerms()
lapply( head( go_terms ), head )
}

\name{loadGeneLists}
\alias{loadGeneLists}
\title{Load Gene Lists}
\description{
Loads gene lists from a file or directory.
}
\usage{
loadGeneLists(location, type = "GMT", sep = "\t", header = FALSE, col = 1)
}
\arguments{
    \item{location}{
    The location of the GMT file or the directory containing the gene lists.
    }
    \item{type}{
    A value indicating whether to load the gene lists from a single GMT file or a directory containing a separate file for each gene list. Acceptable options are "GMT" or "DIR".
    }
    \item{sep}{
    The field separator character by which values on each line are separated.
    }
    \item{header}{
    A logical value indicating whether the gene list files contain a header that should be ignored. Only applicable when type = "DIR".
    }
    \item{col}{
    The column in the gene lists files containing the genes. Only applicable when type = "DIR".
    }
}
\value{
A list of vectors. Each element of the list corresponds to a gene list, and each vector contains the genes in the gene list.
}
\references{
Bennett BD and Bushel PR. goSTAG: Gene Ontology Subtrees to Tag and Annotate Genes within a set. Source Code Biol Med. 2017 Apr 13.
}
\author{
Brian D. Bennett\cr
Pierre R. Bushel
}
\examples{
tf <- tempfile()
writeLines( c(  "Gene_List_1\tNA\tGene1\tGene4",
                "Gene_List_2\tNA\tGene2\tGene7\tGene5",
                "Gene_List_3\tNA\tGene4\tGene8" ), tf )
gene_lists <- loadGeneLists( tf )
lapply( head( gene_lists ), head )

td <- tempdir()
unlink( paste( sep="/", td, list.files(td) ) )
writeLines( c( "Gene1", "Gene4" ), paste(sep="/",td,"Gene_List_1.txt") )
writeLines( c( "Gene2", "Gene7", "Gene5" ), paste(sep="/",td,"Gene_List_2.txt") )
writeLines( c( "Gene4", "Gene8" ), paste(sep="/",td,"Gene_List_3.txt") )
gene_lists <- loadGeneLists( td, type = "dir" )
lapply( head( gene_lists ), head )
}

\name{rat_cancer_therapeutics_gene_lists}
\alias{rat_cancer_therapeutics_gene_lists}
\docType{data}
\title{Rat Cancer Therapeutics Gene Lists}
\description{
Differentially expressed genes from gene expression analysis (Affymetrix GeneChip Rat Genome 230 2.0 arrays) of samples acquired from the bone marrow of rats exposed to cancer therapeutic drugs (topotecan in combination with oxaliplatin) for 1, 6, or 24 hrs. Comparisons were treated samples to time-matched controls using limma with an FDR < 0.05 and absolute fold change > 2.0. Details of the analysis are as previously described (Davis et al., 2015). The raw data are available in the Gene Expression Omnibus under accession number GSE63902.
}
\usage{data(rat_cancer_therapeutics_gene_lists)}
\value{
A list of vectors. Each element of the list corresponds to a gene list, and each vector contains the genes in the gene list.
}
\references{
Davis M, Li J, Knight E, Eldridge SR, Daniels KK, Bushel PR. Toxicogenomics profiling of bone marrow from rats treated with topotecan in combination with oxaliplatin: a mechanistic strategy to inform combination toxicity. Front Genet. 2015 Feb 12;6:14.
}
\examples{
data( rat_cancer_therapeutics_gene_lists )
lapply( head( rat_cancer_therapeutics_gene_lists ), head )
}
\keyword{datasets}
